unit UnitData;

interface

uses
   UnitFunc ;

const
   LAYER_MAX_NUM = 256 ;   // Cő吔
   COLOR_MAX_NUM = 256 ;   // F@ő吔
   LTYPE_MAX_NUM =  32 ;   // ő吔
   WIDTH_MAX_NUM =  16 ;   // ő吔
   MFONT_MAX_NUM =1024 ;   // tHgő吔

type
   TZumenTitle = record       // }ʏb}ʕ\藓
      P_Name : string;        // Ɩ
      C_Name : string;        // H
      C_type : string;        // _敪
      D_title : string;       // }ʖ
      D_number : string;      // }ʔԍ
                              // }ʔԍ + $$ + }ʐō\B$$ȍ~̓IvV
      D_type : string;        // }ʎ
      D_Scale : string;       // ړx
      D_Year : integer;       // }ʍ쐬Nij
      D_Month : integer;      // V     112
      D_Day : integer;        // V     131
      C_Contractor : string;  // 󒍉Ж
      C_Owner : string;       // ƎҖ
   end;

   TZumenPaper = record       // }ʍ\bp
      name : string;          // }ʖ
      typ : integer;          // pTCY(0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
      orient : integer;       // c^敪(0:c,1:)
      x : integer;            // Rp(Pmm)
      y : integer;            // Rpc(Pmm)
   end;

   TZumenLayer = record       // }ʍ\bC
      name  : string;         // C
      Lflag : Integer ;       // 0:\ 1:\
      Color : Integer ;       // CF
      Ltype : Integer ;       // C
      Width : Integer ;       // C
      cnt   : Integer ;       // Cvf
   end;

   TZumenColor = record       // }ʍ\bF
      Red   : Integer ;       // ql
      Green : Integer ;       // fl
      Blue  : Integer ;       // al
      cnt   : Integer ;       // Fvf
   end;

   TZumenLtype = record       // }ʍ\b
      name  : string;         // 햼
      Segment : Integer ;     // ZOg `F0,2,4,8,10@[U`F2,4,6,8
      Pitch : array[0..9] of double;   // esb`
      cnt   : Integer ;       // vf
   end;

   TZumenWidth = record       // }ʍ\b
      Width : double ;        // 
      cnt   : Integer ;       // vf
   end;

    TZumenFont = record       // }ʍ\btHg
      name  : string;         // tHg
      cnt   : Integer ;       // tHgvf
   end;

   TDataClass = class
   public
      { Public 錾 }
      zt : TZumenTitle;    // }ʏb}ʕ\藓
      zp : TZumenPaper;    // }ʍ\bp
      zLay : array of TZumenLayer;     // }ʍ\bC
      zLayN: Integer ;                 // C
      zCol : array of TZumenColor;     // }ʍ\bF
      zColN: Integer ;                 // F
      zLtp : array of TZumenLtype;     // }ʍ\b
      zLtpN: Integer ;                 // 퐔
      zWid : array of TZumenWidth;     // }ʍ\b
      zWidN: Integer ;                 // 
      zFnt : array of TZumenFont;      // }ʍ\btHg
      zFntN: Integer ;                 // tHg
      constructor Create;
      destructor Free;
      procedure DataInit;
      function  StrCheck(s:string) : Boolean;
      procedure PaperSet(t,o,x,y:integer);
      function  LayerNameCheck(n:integer;s:string) : Integer;
      function  AddLayer(s:string;fla,col,ltp,wid:integer) : Boolean;
      function  EditLayer(n:integer;s:string;fla,col,ltp,wid:integer) : Boolean;
      function  AddColor(r,g,b:integer) : Boolean;
      function  EditColor(n:integer;r,g,b:integer) : Boolean;
      function  LtypeNameCheck(n:integer;s:string) : Integer;
      function  AddLtype(s:string;seg:integer;pit:array of double) : Boolean;
      function  EditLtype(n:integer;s:string;seg:integer;pit:array of double) : Boolean;
      function  AddWidth(w:double) : Boolean;
      function  EditWidth(n:integer;w:double) : Boolean;
      function  FontNameCheck(n:integer;s:string) : Integer;
      function  AddFont(s:string) : Boolean;
      function  EditFont(n:integer;s:string) : Boolean;
   private
      { Private 錾 }
   end;

implementation

// 
constructor TDataClass.Create;
begin
   DataInit ;
end;

// 
destructor TDataClass.Free;
begin
   zLay  := nil;
   zLayN := 0;
   zCol  := nil;
   zColN := 0;
   zLtp  := nil;
   zLtpN := 0;
   zWid  := nil;
   zWidN := 0;
   zFnt  := nil;
   zFntN := 0;
end;

// lZbg
procedure TDataClass.DataInit;
var
   i : integer ;
begin
   // 񒷂0偁(NULL)͋Ȃ̂Ŕp󔒂܂
   with zt do begin
      P_Name   := ' ';
      C_Name   := ' ';
      C_type   := ' ';
      D_title  := ' ';
      D_number := ' ';
      D_type   := ' ';
      D_Scale  := '1/1';
      D_Year   := 2011;
      D_Month  := 1;
      D_Day    := 1;
      C_Contractor := ' ';
      C_Owner  := ' ';
   end;
   with zp do begin
      name  := ' ';
      typ   := 0;
      orient:= 1;
      x     := 1189;
      y     := 841;
   end;
   zLay  := nil;
   zLayN := 0;

   zCol  := nil;
   zColN := 16;
   SetLength(zCol,zColN);
   for i:=0 to zColN-1 do zCol[i].cnt := 0 ;
   EditColor( 1,   0,  0,  0);
   EditColor( 2, 255,  0,  0);
   EditColor( 3,   0,255,  0);
   EditColor( 4,   0,  0,255);
   EditColor( 5, 255,255,  0);
   EditColor( 6, 255,  0,255);
   EditColor( 7,   0,255,255);
   EditColor( 8, 255,255,255);
   EditColor( 9, 192,  0,128);
   EditColor(10, 192,128, 64);
   EditColor(11, 255,128,  0);
   EditColor(12, 128,192,128);
   EditColor(13,   0,128,255);
   EditColor(14, 128, 64,255);
   EditColor(15, 192,192,192);
   EditColor(16, 128,128,128);

   zLtp  := nil;
   zLtpN := 16;
   SetLength(zLtp,zLtpN);
   for i:=0 to zLtpN-1 do zLtp[i].cnt := 0 ;
   EditLtype(1,'continuous'                        ,0,[ 0.0,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(2,'dashed'                            ,2,[ 6.0,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(3,'dashed spaced'                     ,2,[ 6.0,6.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(4,'long dashed dotted'                ,4,[12.0,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(5,'long dashed double-dotted'         ,6,[12.0,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(6,'long dashed triplicate-dotted'     ,8,[12.0,1.5,0.25,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0]);
   EditLtype(7,'dotted'                            ,2,[0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(8,'chain'                             ,4,[12.0,1.5,3.5 ,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(9,'chain double dash'                 ,6,[12.0,1.5,3.5 ,1.5,3.5 ,1.5,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(10,'dashed dotted'                    ,4,[6.0 ,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(11,'Double-dashed dotted'             ,6,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(12,'dashed double-dotted'             ,6,[6.0 ,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(13,'double-dashed double-dotted'      ,8,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0]);
   EditLtype(14,'dashed triplicate-dotted'         ,8,[6.0 ,1.5,0.25,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0]);
   EditLtype(15,'double-dashed triplicate-dotted' ,10,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.25,1.5,0.25,1.5]);
   EditLtype(16,'gp'                           ,0,[0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);

   zWid  := nil;
   zWidN := 10;
   SetLength(zWid,zWidN);
   for i:=0 to zWidN-1 do zWid[i].cnt := 0 ;
   EditWidth( 1, 0.13);
   EditWidth( 2, 0.18);
   EditWidth( 3, 0.25);
   EditWidth( 4, 0.35);
   EditWidth( 5, 0.5 );
   EditWidth( 6, 0.7 );
   EditWidth( 7, 1.0 );
   EditWidth( 8, 1.4 );
   EditWidth( 9, 2.0 );
   EditWidth(10, 0.01); // gp

   zFnt  := nil;
   zFntN := 0;
end;

// `FbN
//    (ret) OK : True  NG : False
//     0񒷁256 ǂ`FbN
function TDataClass.StrCheck(s:string) : Boolean;
var
   t : AnsiString ;
   l : integer ;
begin
   t := AnsiString(s) ;
   l := Length(t) ;
   if (l > 0) and (l <= 256) then
      Result := True
   else
      Result := False ;
end;

// pTCYZbg
//    t : (0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
//          {(10:A0~2 11:A0~3 12:A1~3 13:A1~4 14:A2~3 15:A2~4 16:A2~5
//             17:A3~3 18:A3~4 19:A3~5 20:A3~6 21:A3~7 22:A4~3 23:A4~4
//             24:A4~5 25:A4~6 26:A4~7 27:A4~8 28:A4~9)
//          {(30:B0 31:B1 32:B2 33:B3 34:B4 35:B5 36:B6)
//    o : c^敪(0:c,1:)
//    x : Rp(Pmm) t=9̎Ɏw
//    y : Rpc(Pmm) t=9̎Ɏw
procedure TDataClass.PaperSet(t,o,x,y:integer);
begin
   case(t)of
   0: begin
         x := 1189;
         y :=  841;
      end;
   1: begin
         x := 841;
         y := 594;
      end;
   2: begin
         x := 594;
         y := 420;
      end;
   3: begin
         x := 420;
         y := 297;
      end;
   4: begin
         x := 297;
         y := 210;
      end;
   10:begin // A0~2
         x := 1682;
         y := 1189;
      end;
   11:begin // A0~3
         x := 2523;
         y := 1189;
      end;
   12:begin // A1~3
         x := 1783;
         y :=  841;
      end;
   13:begin // A1~4
         x := 2378;
         y :=  841;
      end;
   14:begin // A2~3
         x := 1261;
         y :=  594;
      end;
   15:begin // A2~4
         x := 1682;
         y :=  594;
      end;
   16:begin // A2~5
         x := 2102;
         y :=  594;
      end;
   17:begin // A3~3
         x :=  891;
         y :=  420;
      end;
   18:begin // A3~4
         x := 1189;
         y :=  420;
      end;
   19:begin // A3~5
         x := 1486;
         y :=  420;
      end;
   20:begin // A3~6
         x := 1783;
         y :=  420;
      end;
   21:begin // A3~7
         x := 2080;
         y :=  420;
      end;
   22:begin // A4~3
         x :=  630;
         y :=  297;
      end;
   23:begin // A4~4
         x :=  841;
         y :=  297;
      end;
   24:begin // A4~5
         x := 1051;
         y :=  297;
      end;
   25:begin // A4~6
         x := 1261;
         y :=  297;
      end;
   26:begin // A4~7
         x := 1471;
         y :=  297;
      end;
   27:begin // A4~8
         x := 1682;
         y :=  297;
      end;
   28:begin // A4~9
         x := 1892;
         y :=  297;
      end;
   30:begin // B0
			x := 1456;
			y := 1028;
      end;
   31:begin // B1
			x := 1028;
			y :=  728;
      end;
   32:begin // B2
			x := 728;
			y := 514;
      end;
   33:begin // B3
			x := 514;
			y := 364;
      end;
   34:begin // B4
         x := 364;
			y := 257;
      end;
   35:begin // B5
         x := 257;
			y := 182;
      end;
   36:begin // B6
			x := 182;
			y := 128;
      end;
   end;
   if (t >= 0)and(t <= 4) then begin
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;  // CM[lłꍇɔ
   end
   else if (t >= 10)and(t <= 28)
         or(t >= 30)and(t <= 36) then begin
      t := 9 ;
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;
   end
   else begin
      t := 9 ;
      if (x < 100) then x := 100 ;   // RTCY̏ꍇ̒l`FbN
      if (y < 100) then y := 100 ;   //    100mm`10000mmƂĂ
      if (x > 10000) then x := 10000 ;
      if (y > 10000) then y := 10000 ;
      // p̌
      if (x >= y) then
         o := 1
      else
         o := 0 ;
   end;

   zp.typ      := t ;
   zp.orient   := o ;
   zp.x        := x ;
   zp.y        := y ;
end;

// w肵C̃Cԍ擾
//    n  : `FbNO郌Cԍ(0,1-256)
//    s  : C
// (ret) 1`256FCԍ@0:o^
//    xPlA擪32oCgŃ`FbN
//    C̏d`FbNɂp
function TDataClass.LayerNameCheck(n:integer;s:string) : Integer;
var
   i,j : integer;
   s1,s2 : AnsiString ;
begin
   Result := 0 ;
   s1 := AnsiString(s) ;
   s1 := MidStr2(s1,1,32,j);
   for i:=0 to zLayN-1 do begin
      if (i = (n-1)) then continue;    // w背Cԍ̓`FbNX[
      s2 := AnsiString(zLay[i].name) ;
      s2 := MidStr2(s2,1,32,j);
      if (s1 = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
end;

// C@f[^ڂ̒ǉo^
//    s  : C
//    fla: \tO(0,1)
//    col: CF  (1-256)
//    ltp: C(1-32)
//    wid: C(1-16)
// (ret) True:o^OK@False:NG
function TDataClass.AddLayer(s:string;fla,col,ltp,wid:integer) : Boolean;
begin
   Result := False;
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LayerNameCheck(0,s) > 0) then exit;   // ɃC͎gp
   if (zLayN = LAYER_MAX_NUM) then exit ;    // ȏヌC͓o^s

   if (fla <> 0) then fla := 1;
   if (col < 1)or(col > zColN) then col := 1;
   if (ltp < 1)or(ltp > zLtpN)or(ltp = 16) then ltp := 1;
   if (wid < 1)or(wid > zWidN) then wid := 1;

   Inc(zLayN);
   SetLength(zLay, zLayN);
   with zLay[zLayN-1] do begin
      name  := s ;
      Lflag := fla ;
      Color := col ;
      Ltype := ltp ;
      Width := wid ;
      cnt   := 0 ;
   end;
   Result := True ;
end;

// C@f[^ڂ̕ҏWo^
//    n  : Cԍ(1-256)
//    s  : C
//    fla: \tO(0,1)
//    col: CF  (1-256)
//    ltp: C(1-32)
//    wid: C(1-16)
// (ret) True:o^OK@False:NG
function TDataClass.EditLayer(n:integer;s:string;fla,col,ltp,wid:integer) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zLayN) then exit;        // CԍG[
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LayerNameCheck(n,s) > 0) then exit;   // ɃC͎gp

   if (fla <> 0) then fla := 1;
   if (col < 1)or(col > zColN) then col := 1;
   if (ltp < 1)or(ltp > zLtpN)or(ltp = 16) then ltp := 1;
   if (wid < 1)or(wid > zWidN) then wid := 1;

   with zLay[n-1] do begin
      name  := s ;
      Lflag := fla ;
      Color := col ;
      Ltype := ltp ;
      Width := wid ;
   end;
   Result := True ;
end;

// F@f[^ڂ̒ǉo^
//    r : ql(0-255)
//    g : fl(0-255)
//    b : al(0-255)
// (ret) True:o^OK@False:NG
function TDataClass.AddColor(r,g,b:integer) : Boolean;
begin
   Result := False;
   if (zColN = COLOR_MAX_NUM) then exit ;    // ȏF͓o^s

   if (r < 0) then r := 0;
   if (g < 0) then g := 0;
   if (b < 0) then b := 0;
   if (r > 255) then r := 255;
   if (g > 255) then g := 255;
   if (b > 255) then b := 255;

   Inc(zColN);
   SetLength(zCol, zColN);
   with zCol[zColN-1] do begin
      Red   := r ;
      Green := g ;
      Blue  := b ;
      cnt   := 0 ;
   end;
   Result := True ;
end;

// F@f[^ڂ̕ҏWo^
//    n : Fԍ(1-256)
//    r : ql(0-255)
//    g : fl(0-255)
//    b : al(0-255)
// (ret) True:o^OK@False:NG
//    Fԍ 1-16̕ҏWo^\łASXFdlł͗pґɂҏW͕s
function TDataClass.EditColor(n:integer;r,g,b:integer) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zColN) then exit;        // FԍG[

   if (r < 0) then r := 0;
   if (g < 0) then g := 0;
   if (b < 0) then b := 0;
   if (r > 255) then r := 255;
   if (g > 255) then g := 255;
   if (b > 255) then b := 255;

   with zCol[n-1] do begin
      Red   := r ;
      Green := g ;
      Blue  := b ;
   end;
   Result := True ;
end;

// w肵햼̐ԍ擾
//    n  : `FbNOԍ(0,1-32)
//    s  : 햼
// (ret) 1`32Fԍ@0:o^
//   햼̏d`FbNɂp
function TDataClass.LtypeNameCheck(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to zLtpN-1 do begin
      if (i = (n-1)) then continue;    // wԍ̓`FbNX[
      s2 := zLtp[i].name ;
      if (s = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    s  : 햼
//    seg: ZOg(0-10)
//    pit: esb` (10vf)
// (ret) True:o^OK@False:NG
function TDataClass.AddLtype(s:string;seg:integer;pit:array of double) : Boolean;
var
   i : integer;
begin
   Result := False;
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LtypeNameCheck(0,s) > 0) then exit;   // ɐ햼͎gp
   if (zLtpN = LTYPE_MAX_NUM) then exit ;    // ȏ͓o^s

   if (seg < 0)or(seg > 10) then seg := 0;
   for i:=0 to 9 do begin
      if (pit[i] <    0.0) then pit[i] :=    0.0;
      if (pit[i] > 1000.0) then pit[i] := 1000.0;
   end;

   Inc(zLtpN);
   SetLength(zLtp, zLtpN);
   with zLtp[zLtpN-1] do begin
      name     := s ;
      Segment  := seg ;
      for i:=0 to 9 do
         Pitch[i] := 0.0 ;
      for i:=0 to seg-1 do
         Pitch[i] := pit[i] ;
      cnt   := 0 ;
   end;
   Result := True ;
end;

// @f[^ڂ̕ҏWo^
//    n  : ԍ(1-32)
//    s  : 햼
//    seg: ZOg(0-10)
//    pit: esb` (10vf)
// (ret) True:o^OK@False:NG
function TDataClass.EditLtype(n:integer;s:string;seg:integer;pit:array of double) : Boolean;
var
   i : integer;
begin
   Result := False;
   if (n < 1)or(n > zLtpN) then exit;        // ԍG[
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LtypeNameCheck(n,s) > 0) then exit;   // ɐ햼͎gp

   if (seg < 0)or(seg > 10) then seg := 0;
   for i:=0 to 9 do begin
      if (pit[i] <    0.0) then pit[i] :=    0.0;
      if (pit[i] > 1000.0) then pit[i] := 1000.0;
   end;

   with zLtp[n-1] do begin
      name     := s ;
      Segment  := seg ;
      for i:=0 to 9 do
         Pitch[i] := 0.0 ;
      for i:=0 to seg-1 do
         Pitch[i] := pit[i] ;
   end;
   Result := True ;
end;

// @f[^ڂ̒ǉo^
//    w : (0.01-1000)
// (ret) True:o^OK@False:NG
function TDataClass.AddWidth(w:double) : Boolean;
begin
   Result := False;
   if (zWidN = WIDTH_MAX_NUM) then exit ;    // ȏ͓o^s

   if (w <   0.01) then w :=   0.01;
   if (w > 1000.0) then w := 1000.0;   // SXFdlł 010^15Ƃ܂

   Inc(zWidN);
   SetLength(zWid, zWidN);
   with zWid[zWidN-1] do begin
      Width := w ;
      cnt   := 0 ;
   end;
   Result := True ;
end;

// @f[^ڂ̒ǉo^
//    n : ԍ(1-16)
//    w : (0.01-1000)
// (ret) True:o^OK@False:NG
function TDataClass.EditWidth(n:integer;w:double) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zWidN) then exit;        // ԍG[

   if (w <   0.01) then w :=   0.01;
   if (w > 1000.0) then w := 1000.0;   // SXFdlł 010^15Ƃ܂

   with zWid[n-1] do begin
      Width := w ;
   end;
   Result := True ;
end;

// w肵tHg̕tHgԍ擾
//    n  : `FbNO镶tHgԍ(0,1-1024)
//    s  : tHg
// (ret) 1`1024Fԍ@0:o^
function TDataClass.FontNameCheck(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to zFntN-1 do begin
      if (i = (n-1)) then continue;    // w蕶tHgԍ̓`FbNX[
      s2 := zFnt[i].name ;
      if (s = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
end;

// tHg@f[^ڂ̒ǉo^
//    s  : tHg
// (ret) True:o^OK@False:NG
function TDataClass.AddFont(s:string) : Boolean;
begin
   Result := False;
   if not(StrCheck(s)) then exit;               // 񐔃`FbN
   // if (FontNameCheck(0,s) > 0) then exit;    // ***ɕtHg͎gp***d`FbN͂Ȃ
   if (zFntN = MFONT_MAX_NUM) then exit ;       // ȏ㕶tHg͓o^s

   Inc(zFntN);
   SetLength(zFnt, zFntN);
   with zFnt[zFntN-1] do begin
      name  := s ;
      cnt   := 0 ;
   end;
   Result := True ;
end;

// tHg@f[^ڂ̕ҏWo^
//    n  : tHgԍ(1-1024)
//    s  : tHg
// (ret) True:o^OK@False:NG
function TDataClass.EditFont(n:integer;s:string) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zFntN) then exit;           // tHgԍG[
   if not(StrCheck(s)) then exit;               // 񐔃`FbN
   // if (FontNameCheck(n,s) > 0) then exit;    // ***ɕtHg͎gp***d`FbN͂Ȃ

   with zFnt[n-1] do begin
      name  := s ;
   end;
   Result := True ;
end;


end.
